// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * Specialized 61850 ZBAT class  LN: Battery   Name: ZBAT
 * </pre>
 *
 * Protobuf type {@code essmodule.EssEventZBAT}
 */
public final class EssEventZBAT extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.EssEventZBAT)
    EssEventZBATOrBuilder {
private static final long serialVersionUID = 0L;
  // Use EssEventZBAT.newBuilder() to construct.
  private EssEventZBAT(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private EssEventZBAT() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new EssEventZBAT();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_EssEventZBAT_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_EssEventZBAT_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.EssEventZBAT.class, openfmb.essmodule.EssEventZBAT.Builder.class);
  }

  public static final int LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNodeForEventAndStatus field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNodeForEventAndStatus.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }

  public static final int BATHI_FIELD_NUMBER = 2;
  private openfmb.commonmodule.StatusSPS batHi_;
  /**
   * <pre>
   * If true, the battery is in overcharge (voltage or current) condition.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatHi = 2;</code>
   * @return Whether the batHi field is set.
   */
  @java.lang.Override
  public boolean hasBatHi() {
    return batHi_ != null;
  }
  /**
   * <pre>
   * If true, the battery is in overcharge (voltage or current) condition.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatHi = 2;</code>
   * @return The batHi.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getBatHi() {
    return batHi_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batHi_;
  }
  /**
   * <pre>
   * If true, the battery is in overcharge (voltage or current) condition.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatHi = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getBatHiOrBuilder() {
    return batHi_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batHi_;
  }

  public static final int BATLO_FIELD_NUMBER = 3;
  private openfmb.commonmodule.StatusSPS batLo_;
  /**
   * <pre>
   * If true, the battery voltage or charge has dropped below a pre-set level.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatLo = 3;</code>
   * @return Whether the batLo field is set.
   */
  @java.lang.Override
  public boolean hasBatLo() {
    return batLo_ != null;
  }
  /**
   * <pre>
   * If true, the battery voltage or charge has dropped below a pre-set level.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatLo = 3;</code>
   * @return The batLo.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getBatLo() {
    return batLo_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batLo_;
  }
  /**
   * <pre>
   * If true, the battery voltage or charge has dropped below a pre-set level.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatLo = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getBatLoOrBuilder() {
    return batLo_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batLo_;
  }

  public static final int BATST_FIELD_NUMBER = 4;
  private openfmb.commonmodule.StatusSPS batSt_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatSt = 4;</code>
   * @return Whether the batSt field is set.
   */
  @java.lang.Override
  public boolean hasBatSt() {
    return batSt_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatSt = 4;</code>
   * @return The batSt.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getBatSt() {
    return batSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batSt_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.StatusSPS BatSt = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getBatStOrBuilder() {
    return batSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batSt_;
  }

  public static final int SOC_FIELD_NUMBER = 5;
  private openfmb.commonmodule.MV soc_;
  /**
   * <pre>
   * State of charge (in percentage)
   * </pre>
   *
   * <code>.commonmodule.MV Soc = 5;</code>
   * @return Whether the soc field is set.
   */
  @java.lang.Override
  public boolean hasSoc() {
    return soc_ != null;
  }
  /**
   * <pre>
   * State of charge (in percentage)
   * </pre>
   *
   * <code>.commonmodule.MV Soc = 5;</code>
   * @return The soc.
   */
  @java.lang.Override
  public openfmb.commonmodule.MV getSoc() {
    return soc_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soc_;
  }
  /**
   * <pre>
   * State of charge (in percentage)
   * </pre>
   *
   * <code>.commonmodule.MV Soc = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.MVOrBuilder getSocOrBuilder() {
    return soc_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soc_;
  }

  public static final int STDBY_FIELD_NUMBER = 6;
  private openfmb.commonmodule.StatusSPS stdby_;
  /**
   * <pre>
   * If stVal TRUE, the device is in standby.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Stdby = 6;</code>
   * @return Whether the stdby field is set.
   */
  @java.lang.Override
  public boolean hasStdby() {
    return stdby_ != null;
  }
  /**
   * <pre>
   * If stVal TRUE, the device is in standby.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Stdby = 6;</code>
   * @return The stdby.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getStdby() {
    return stdby_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : stdby_;
  }
  /**
   * <pre>
   * If stVal TRUE, the device is in standby.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Stdby = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getStdbyOrBuilder() {
    return stdby_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : stdby_;
  }

  public static final int SOH_FIELD_NUMBER = 7;
  private openfmb.commonmodule.MV soH_;
  /**
   * <pre>
   * State of health of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.MV SoH = 7;</code>
   * @return Whether the soH field is set.
   */
  @java.lang.Override
  public boolean hasSoH() {
    return soH_ != null;
  }
  /**
   * <pre>
   * State of health of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.MV SoH = 7;</code>
   * @return The soH.
   */
  @java.lang.Override
  public openfmb.commonmodule.MV getSoH() {
    return soH_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soH_;
  }
  /**
   * <pre>
   * State of health of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.MV SoH = 7;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.MVOrBuilder getSoHOrBuilder() {
    return soH_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soH_;
  }

  public static final int WHAVAIL_FIELD_NUMBER = 8;
  private openfmb.commonmodule.MV wHAvail_;
  /**
   * <pre>
   * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
   * </pre>
   *
   * <code>.commonmodule.MV WHAvail = 8;</code>
   * @return Whether the wHAvail field is set.
   */
  @java.lang.Override
  public boolean hasWHAvail() {
    return wHAvail_ != null;
  }
  /**
   * <pre>
   * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
   * </pre>
   *
   * <code>.commonmodule.MV WHAvail = 8;</code>
   * @return The wHAvail.
   */
  @java.lang.Override
  public openfmb.commonmodule.MV getWHAvail() {
    return wHAvail_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : wHAvail_;
  }
  /**
   * <pre>
   * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
   * </pre>
   *
   * <code>.commonmodule.MV WHAvail = 8;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.MVOrBuilder getWHAvailOrBuilder() {
    return wHAvail_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : wHAvail_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNodeForEventAndStatus_ != null) {
      output.writeMessage(1, getLogicalNodeForEventAndStatus());
    }
    if (batHi_ != null) {
      output.writeMessage(2, getBatHi());
    }
    if (batLo_ != null) {
      output.writeMessage(3, getBatLo());
    }
    if (batSt_ != null) {
      output.writeMessage(4, getBatSt());
    }
    if (soc_ != null) {
      output.writeMessage(5, getSoc());
    }
    if (stdby_ != null) {
      output.writeMessage(6, getStdby());
    }
    if (soH_ != null) {
      output.writeMessage(7, getSoH());
    }
    if (wHAvail_ != null) {
      output.writeMessage(8, getWHAvail());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNodeForEventAndStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNodeForEventAndStatus());
    }
    if (batHi_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getBatHi());
    }
    if (batLo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getBatLo());
    }
    if (batSt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getBatSt());
    }
    if (soc_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getSoc());
    }
    if (stdby_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getStdby());
    }
    if (soH_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getSoH());
    }
    if (wHAvail_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getWHAvail());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.EssEventZBAT)) {
      return super.equals(obj);
    }
    openfmb.essmodule.EssEventZBAT other = (openfmb.essmodule.EssEventZBAT) obj;

    if (hasLogicalNodeForEventAndStatus() != other.hasLogicalNodeForEventAndStatus()) return false;
    if (hasLogicalNodeForEventAndStatus()) {
      if (!getLogicalNodeForEventAndStatus()
          .equals(other.getLogicalNodeForEventAndStatus())) return false;
    }
    if (hasBatHi() != other.hasBatHi()) return false;
    if (hasBatHi()) {
      if (!getBatHi()
          .equals(other.getBatHi())) return false;
    }
    if (hasBatLo() != other.hasBatLo()) return false;
    if (hasBatLo()) {
      if (!getBatLo()
          .equals(other.getBatLo())) return false;
    }
    if (hasBatSt() != other.hasBatSt()) return false;
    if (hasBatSt()) {
      if (!getBatSt()
          .equals(other.getBatSt())) return false;
    }
    if (hasSoc() != other.hasSoc()) return false;
    if (hasSoc()) {
      if (!getSoc()
          .equals(other.getSoc())) return false;
    }
    if (hasStdby() != other.hasStdby()) return false;
    if (hasStdby()) {
      if (!getStdby()
          .equals(other.getStdby())) return false;
    }
    if (hasSoH() != other.hasSoH()) return false;
    if (hasSoH()) {
      if (!getSoH()
          .equals(other.getSoH())) return false;
    }
    if (hasWHAvail() != other.hasWHAvail()) return false;
    if (hasWHAvail()) {
      if (!getWHAvail()
          .equals(other.getWHAvail())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNodeForEventAndStatus()) {
      hash = (37 * hash) + LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNodeForEventAndStatus().hashCode();
    }
    if (hasBatHi()) {
      hash = (37 * hash) + BATHI_FIELD_NUMBER;
      hash = (53 * hash) + getBatHi().hashCode();
    }
    if (hasBatLo()) {
      hash = (37 * hash) + BATLO_FIELD_NUMBER;
      hash = (53 * hash) + getBatLo().hashCode();
    }
    if (hasBatSt()) {
      hash = (37 * hash) + BATST_FIELD_NUMBER;
      hash = (53 * hash) + getBatSt().hashCode();
    }
    if (hasSoc()) {
      hash = (37 * hash) + SOC_FIELD_NUMBER;
      hash = (53 * hash) + getSoc().hashCode();
    }
    if (hasStdby()) {
      hash = (37 * hash) + STDBY_FIELD_NUMBER;
      hash = (53 * hash) + getStdby().hashCode();
    }
    if (hasSoH()) {
      hash = (37 * hash) + SOH_FIELD_NUMBER;
      hash = (53 * hash) + getSoH().hashCode();
    }
    if (hasWHAvail()) {
      hash = (37 * hash) + WHAVAIL_FIELD_NUMBER;
      hash = (53 * hash) + getWHAvail().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.EssEventZBAT parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.EssEventZBAT parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.EssEventZBAT parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.EssEventZBAT parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.EssEventZBAT prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Specialized 61850 ZBAT class  LN: Battery   Name: ZBAT
   * </pre>
   *
   * Protobuf type {@code essmodule.EssEventZBAT}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.EssEventZBAT)
      openfmb.essmodule.EssEventZBATOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_EssEventZBAT_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_EssEventZBAT_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.EssEventZBAT.class, openfmb.essmodule.EssEventZBAT.Builder.class);
    }

    // Construct using openfmb.essmodule.EssEventZBAT.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      batHi_ = null;
      if (batHiBuilder_ != null) {
        batHiBuilder_.dispose();
        batHiBuilder_ = null;
      }
      batLo_ = null;
      if (batLoBuilder_ != null) {
        batLoBuilder_.dispose();
        batLoBuilder_ = null;
      }
      batSt_ = null;
      if (batStBuilder_ != null) {
        batStBuilder_.dispose();
        batStBuilder_ = null;
      }
      soc_ = null;
      if (socBuilder_ != null) {
        socBuilder_.dispose();
        socBuilder_ = null;
      }
      stdby_ = null;
      if (stdbyBuilder_ != null) {
        stdbyBuilder_.dispose();
        stdbyBuilder_ = null;
      }
      soH_ = null;
      if (soHBuilder_ != null) {
        soHBuilder_.dispose();
        soHBuilder_ = null;
      }
      wHAvail_ = null;
      if (wHAvailBuilder_ != null) {
        wHAvailBuilder_.dispose();
        wHAvailBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_EssEventZBAT_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.EssEventZBAT getDefaultInstanceForType() {
      return openfmb.essmodule.EssEventZBAT.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.EssEventZBAT build() {
      openfmb.essmodule.EssEventZBAT result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.EssEventZBAT buildPartial() {
      openfmb.essmodule.EssEventZBAT result = new openfmb.essmodule.EssEventZBAT(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.EssEventZBAT result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNodeForEventAndStatus_ = logicalNodeForEventAndStatusBuilder_ == null
            ? logicalNodeForEventAndStatus_
            : logicalNodeForEventAndStatusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.batHi_ = batHiBuilder_ == null
            ? batHi_
            : batHiBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.batLo_ = batLoBuilder_ == null
            ? batLo_
            : batLoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.batSt_ = batStBuilder_ == null
            ? batSt_
            : batStBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.soc_ = socBuilder_ == null
            ? soc_
            : socBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.stdby_ = stdbyBuilder_ == null
            ? stdby_
            : stdbyBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.soH_ = soHBuilder_ == null
            ? soH_
            : soHBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.wHAvail_ = wHAvailBuilder_ == null
            ? wHAvail_
            : wHAvailBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.EssEventZBAT) {
        return mergeFrom((openfmb.essmodule.EssEventZBAT)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.EssEventZBAT other) {
      if (other == openfmb.essmodule.EssEventZBAT.getDefaultInstance()) return this;
      if (other.hasLogicalNodeForEventAndStatus()) {
        mergeLogicalNodeForEventAndStatus(other.getLogicalNodeForEventAndStatus());
      }
      if (other.hasBatHi()) {
        mergeBatHi(other.getBatHi());
      }
      if (other.hasBatLo()) {
        mergeBatLo(other.getBatLo());
      }
      if (other.hasBatSt()) {
        mergeBatSt(other.getBatSt());
      }
      if (other.hasSoc()) {
        mergeSoc(other.getSoc());
      }
      if (other.hasStdby()) {
        mergeStdby(other.getStdby());
      }
      if (other.hasSoH()) {
        mergeSoH(other.getSoH());
      }
      if (other.hasWHAvail()) {
        mergeWHAvail(other.getWHAvail());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeForEventAndStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getBatHiFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getBatLoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getBatStFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getSocFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getStdbyFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getSoHFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getWHAvailFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> logicalNodeForEventAndStatusBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNodeForEventAndStatus field is set.
     */
    public boolean hasLogicalNodeForEventAndStatus() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNodeForEventAndStatus.
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      } else {
        return logicalNodeForEventAndStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNodeForEventAndStatus_ = value;
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(
        openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder builderForValue) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatus_ = builderForValue.build();
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNodeForEventAndStatus_ != null &&
          logicalNodeForEventAndStatus_ != openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance()) {
          getLogicalNodeForEventAndStatusBuilder().mergeFrom(value);
        } else {
          logicalNodeForEventAndStatus_ = value;
        }
      } else {
        logicalNodeForEventAndStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNodeForEventAndStatus() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder getLogicalNodeForEventAndStatusBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeForEventAndStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        return logicalNodeForEventAndStatusBuilder_.getMessageOrBuilder();
      } else {
        return logicalNodeForEventAndStatus_ == null ?
            openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> 
        getLogicalNodeForEventAndStatusFieldBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder>(
                getLogicalNodeForEventAndStatus(),
                getParentForChildren(),
                isClean());
        logicalNodeForEventAndStatus_ = null;
      }
      return logicalNodeForEventAndStatusBuilder_;
    }

    private openfmb.commonmodule.StatusSPS batHi_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> batHiBuilder_;
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     * @return Whether the batHi field is set.
     */
    public boolean hasBatHi() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     * @return The batHi.
     */
    public openfmb.commonmodule.StatusSPS getBatHi() {
      if (batHiBuilder_ == null) {
        return batHi_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batHi_;
      } else {
        return batHiBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public Builder setBatHi(openfmb.commonmodule.StatusSPS value) {
      if (batHiBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        batHi_ = value;
      } else {
        batHiBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public Builder setBatHi(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (batHiBuilder_ == null) {
        batHi_ = builderForValue.build();
      } else {
        batHiBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public Builder mergeBatHi(openfmb.commonmodule.StatusSPS value) {
      if (batHiBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          batHi_ != null &&
          batHi_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getBatHiBuilder().mergeFrom(value);
        } else {
          batHi_ = value;
        }
      } else {
        batHiBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public Builder clearBatHi() {
      bitField0_ = (bitField0_ & ~0x00000002);
      batHi_ = null;
      if (batHiBuilder_ != null) {
        batHiBuilder_.dispose();
        batHiBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getBatHiBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getBatHiFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getBatHiOrBuilder() {
      if (batHiBuilder_ != null) {
        return batHiBuilder_.getMessageOrBuilder();
      } else {
        return batHi_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : batHi_;
      }
    }
    /**
     * <pre>
     * If true, the battery is in overcharge (voltage or current) condition.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatHi = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getBatHiFieldBuilder() {
      if (batHiBuilder_ == null) {
        batHiBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getBatHi(),
                getParentForChildren(),
                isClean());
        batHi_ = null;
      }
      return batHiBuilder_;
    }

    private openfmb.commonmodule.StatusSPS batLo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> batLoBuilder_;
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     * @return Whether the batLo field is set.
     */
    public boolean hasBatLo() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     * @return The batLo.
     */
    public openfmb.commonmodule.StatusSPS getBatLo() {
      if (batLoBuilder_ == null) {
        return batLo_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batLo_;
      } else {
        return batLoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public Builder setBatLo(openfmb.commonmodule.StatusSPS value) {
      if (batLoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        batLo_ = value;
      } else {
        batLoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public Builder setBatLo(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (batLoBuilder_ == null) {
        batLo_ = builderForValue.build();
      } else {
        batLoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public Builder mergeBatLo(openfmb.commonmodule.StatusSPS value) {
      if (batLoBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          batLo_ != null &&
          batLo_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getBatLoBuilder().mergeFrom(value);
        } else {
          batLo_ = value;
        }
      } else {
        batLoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public Builder clearBatLo() {
      bitField0_ = (bitField0_ & ~0x00000004);
      batLo_ = null;
      if (batLoBuilder_ != null) {
        batLoBuilder_.dispose();
        batLoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getBatLoBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getBatLoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getBatLoOrBuilder() {
      if (batLoBuilder_ != null) {
        return batLoBuilder_.getMessageOrBuilder();
      } else {
        return batLo_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : batLo_;
      }
    }
    /**
     * <pre>
     * If true, the battery voltage or charge has dropped below a pre-set level.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatLo = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getBatLoFieldBuilder() {
      if (batLoBuilder_ == null) {
        batLoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getBatLo(),
                getParentForChildren(),
                isClean());
        batLo_ = null;
      }
      return batLoBuilder_;
    }

    private openfmb.commonmodule.StatusSPS batSt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> batStBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     * @return Whether the batSt field is set.
     */
    public boolean hasBatSt() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     * @return The batSt.
     */
    public openfmb.commonmodule.StatusSPS getBatSt() {
      if (batStBuilder_ == null) {
        return batSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : batSt_;
      } else {
        return batStBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public Builder setBatSt(openfmb.commonmodule.StatusSPS value) {
      if (batStBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        batSt_ = value;
      } else {
        batStBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public Builder setBatSt(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (batStBuilder_ == null) {
        batSt_ = builderForValue.build();
      } else {
        batStBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public Builder mergeBatSt(openfmb.commonmodule.StatusSPS value) {
      if (batStBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          batSt_ != null &&
          batSt_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getBatStBuilder().mergeFrom(value);
        } else {
          batSt_ = value;
        }
      } else {
        batStBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public Builder clearBatSt() {
      bitField0_ = (bitField0_ & ~0x00000008);
      batSt_ = null;
      if (batStBuilder_ != null) {
        batStBuilder_.dispose();
        batStBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getBatStBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getBatStFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getBatStOrBuilder() {
      if (batStBuilder_ != null) {
        return batStBuilder_.getMessageOrBuilder();
      } else {
        return batSt_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : batSt_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.StatusSPS BatSt = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getBatStFieldBuilder() {
      if (batStBuilder_ == null) {
        batStBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getBatSt(),
                getParentForChildren(),
                isClean());
        batSt_ = null;
      }
      return batStBuilder_;
    }

    private openfmb.commonmodule.MV soc_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> socBuilder_;
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     * @return Whether the soc field is set.
     */
    public boolean hasSoc() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     * @return The soc.
     */
    public openfmb.commonmodule.MV getSoc() {
      if (socBuilder_ == null) {
        return soc_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soc_;
      } else {
        return socBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public Builder setSoc(openfmb.commonmodule.MV value) {
      if (socBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        soc_ = value;
      } else {
        socBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public Builder setSoc(
        openfmb.commonmodule.MV.Builder builderForValue) {
      if (socBuilder_ == null) {
        soc_ = builderForValue.build();
      } else {
        socBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public Builder mergeSoc(openfmb.commonmodule.MV value) {
      if (socBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          soc_ != null &&
          soc_ != openfmb.commonmodule.MV.getDefaultInstance()) {
          getSocBuilder().mergeFrom(value);
        } else {
          soc_ = value;
        }
      } else {
        socBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public Builder clearSoc() {
      bitField0_ = (bitField0_ & ~0x00000010);
      soc_ = null;
      if (socBuilder_ != null) {
        socBuilder_.dispose();
        socBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public openfmb.commonmodule.MV.Builder getSocBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getSocFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    public openfmb.commonmodule.MVOrBuilder getSocOrBuilder() {
      if (socBuilder_ != null) {
        return socBuilder_.getMessageOrBuilder();
      } else {
        return soc_ == null ?
            openfmb.commonmodule.MV.getDefaultInstance() : soc_;
      }
    }
    /**
     * <pre>
     * State of charge (in percentage)
     * </pre>
     *
     * <code>.commonmodule.MV Soc = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> 
        getSocFieldBuilder() {
      if (socBuilder_ == null) {
        socBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder>(
                getSoc(),
                getParentForChildren(),
                isClean());
        soc_ = null;
      }
      return socBuilder_;
    }

    private openfmb.commonmodule.StatusSPS stdby_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> stdbyBuilder_;
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     * @return Whether the stdby field is set.
     */
    public boolean hasStdby() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     * @return The stdby.
     */
    public openfmb.commonmodule.StatusSPS getStdby() {
      if (stdbyBuilder_ == null) {
        return stdby_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : stdby_;
      } else {
        return stdbyBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public Builder setStdby(openfmb.commonmodule.StatusSPS value) {
      if (stdbyBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        stdby_ = value;
      } else {
        stdbyBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public Builder setStdby(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (stdbyBuilder_ == null) {
        stdby_ = builderForValue.build();
      } else {
        stdbyBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public Builder mergeStdby(openfmb.commonmodule.StatusSPS value) {
      if (stdbyBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          stdby_ != null &&
          stdby_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getStdbyBuilder().mergeFrom(value);
        } else {
          stdby_ = value;
        }
      } else {
        stdbyBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public Builder clearStdby() {
      bitField0_ = (bitField0_ & ~0x00000020);
      stdby_ = null;
      if (stdbyBuilder_ != null) {
        stdbyBuilder_.dispose();
        stdbyBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getStdbyBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getStdbyFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getStdbyOrBuilder() {
      if (stdbyBuilder_ != null) {
        return stdbyBuilder_.getMessageOrBuilder();
      } else {
        return stdby_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : stdby_;
      }
    }
    /**
     * <pre>
     * If stVal TRUE, the device is in standby.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Stdby = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getStdbyFieldBuilder() {
      if (stdbyBuilder_ == null) {
        stdbyBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getStdby(),
                getParentForChildren(),
                isClean());
        stdby_ = null;
      }
      return stdbyBuilder_;
    }

    private openfmb.commonmodule.MV soH_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> soHBuilder_;
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     * @return Whether the soH field is set.
     */
    public boolean hasSoH() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     * @return The soH.
     */
    public openfmb.commonmodule.MV getSoH() {
      if (soHBuilder_ == null) {
        return soH_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : soH_;
      } else {
        return soHBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public Builder setSoH(openfmb.commonmodule.MV value) {
      if (soHBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        soH_ = value;
      } else {
        soHBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public Builder setSoH(
        openfmb.commonmodule.MV.Builder builderForValue) {
      if (soHBuilder_ == null) {
        soH_ = builderForValue.build();
      } else {
        soHBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public Builder mergeSoH(openfmb.commonmodule.MV value) {
      if (soHBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          soH_ != null &&
          soH_ != openfmb.commonmodule.MV.getDefaultInstance()) {
          getSoHBuilder().mergeFrom(value);
        } else {
          soH_ = value;
        }
      } else {
        soHBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public Builder clearSoH() {
      bitField0_ = (bitField0_ & ~0x00000040);
      soH_ = null;
      if (soHBuilder_ != null) {
        soHBuilder_.dispose();
        soHBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public openfmb.commonmodule.MV.Builder getSoHBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getSoHFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    public openfmb.commonmodule.MVOrBuilder getSoHOrBuilder() {
      if (soHBuilder_ != null) {
        return soHBuilder_.getMessageOrBuilder();
      } else {
        return soH_ == null ?
            openfmb.commonmodule.MV.getDefaultInstance() : soH_;
      }
    }
    /**
     * <pre>
     * State of health of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.MV SoH = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> 
        getSoHFieldBuilder() {
      if (soHBuilder_ == null) {
        soHBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder>(
                getSoH(),
                getParentForChildren(),
                isClean());
        soH_ = null;
      }
      return soHBuilder_;
    }

    private openfmb.commonmodule.MV wHAvail_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> wHAvailBuilder_;
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     * @return Whether the wHAvail field is set.
     */
    public boolean hasWHAvail() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     * @return The wHAvail.
     */
    public openfmb.commonmodule.MV getWHAvail() {
      if (wHAvailBuilder_ == null) {
        return wHAvail_ == null ? openfmb.commonmodule.MV.getDefaultInstance() : wHAvail_;
      } else {
        return wHAvailBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public Builder setWHAvail(openfmb.commonmodule.MV value) {
      if (wHAvailBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wHAvail_ = value;
      } else {
        wHAvailBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public Builder setWHAvail(
        openfmb.commonmodule.MV.Builder builderForValue) {
      if (wHAvailBuilder_ == null) {
        wHAvail_ = builderForValue.build();
      } else {
        wHAvailBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public Builder mergeWHAvail(openfmb.commonmodule.MV value) {
      if (wHAvailBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          wHAvail_ != null &&
          wHAvail_ != openfmb.commonmodule.MV.getDefaultInstance()) {
          getWHAvailBuilder().mergeFrom(value);
        } else {
          wHAvail_ = value;
        }
      } else {
        wHAvailBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public Builder clearWHAvail() {
      bitField0_ = (bitField0_ & ~0x00000080);
      wHAvail_ = null;
      if (wHAvailBuilder_ != null) {
        wHAvailBuilder_.dispose();
        wHAvailBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public openfmb.commonmodule.MV.Builder getWHAvailBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getWHAvailFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    public openfmb.commonmodule.MVOrBuilder getWHAvailOrBuilder() {
      if (wHAvailBuilder_ != null) {
        return wHAvailBuilder_.getMessageOrBuilder();
      } else {
        return wHAvail_ == null ?
            openfmb.commonmodule.MV.getDefaultInstance() : wHAvail_;
      }
    }
    /**
     * <pre>
     * Energy available of the DER storage (WHAvail = WHRtg * SoC * SoH)
     * </pre>
     *
     * <code>.commonmodule.MV WHAvail = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder> 
        getWHAvailFieldBuilder() {
      if (wHAvailBuilder_ == null) {
        wHAvailBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.MV, openfmb.commonmodule.MV.Builder, openfmb.commonmodule.MVOrBuilder>(
                getWHAvail(),
                getParentForChildren(),
                isClean());
        wHAvail_ = null;
      }
      return wHAvailBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.EssEventZBAT)
  }

  // @@protoc_insertion_point(class_scope:essmodule.EssEventZBAT)
  private static final openfmb.essmodule.EssEventZBAT DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.EssEventZBAT();
  }

  public static openfmb.essmodule.EssEventZBAT getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<EssEventZBAT>
      PARSER = new com.google.protobuf.AbstractParser<EssEventZBAT>() {
    @java.lang.Override
    public EssEventZBAT parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<EssEventZBAT> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<EssEventZBAT> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.EssEventZBAT getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

